package ru.ifmo.tracklayer.gui;

import java.awt.AWTEvent;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;

import javax.swing.*;

import ru.ifmo.tracklayer.co.Tracklayer;
import ru.ifmo.tracklayer.ep.ScreenEventProvider;


public class GUIFrame extends JFrame {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private class ViewPanel extends JPanel {
		/**
		 * 
		 */
		private static final long serialVersionUID = 1L;

		public void paintComponent(Graphics g) {
			Tracklayer.drawScreen(g);
		}
	}
	
	private ViewPanel viewPanel = new ViewPanel();
	private JButton startStop = new JButton();
	private JButton pauseContinue = new JButton();
	
	
	private GUIFrame() {
	    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
	    init();
	 }

	private void init() {
	    setSize(new Dimension(800, 250));
	    setTitle("TrackLayer");
	    
	    startStop.setText("Start");
	    startStop.addActionListener(
	        new ActionListener() {
	            public void actionPerformed(ActionEvent e) {
	            	ScreenEventProvider.startStop();
	            }
	        }
	    	);
	    
	    pauseContinue.setText("Pause");
	    pauseContinue.addActionListener(
	        new ActionListener() {
	            public void actionPerformed(ActionEvent e) {
	            	ScreenEventProvider.pauseContinue();
	            }
	        }
	    	);
	    pauseContinue.setEnabled(false);
	    
	    JPanel buttonsPanel = new JPanel(new BorderLayout());
	    buttonsPanel.add(startStop, BorderLayout.WEST);
	    buttonsPanel.add(pauseContinue, BorderLayout.EAST);
	    
	    JSplitPane splitPane = new JSplitPane(JSplitPane.VERTICAL_SPLIT);
	    splitPane.add(buttonsPanel,JSplitPane.TOP);
	    splitPane.add(viewPanel,JSplitPane.BOTTOM);
	    this.getContentPane().add(splitPane);
	}

	protected void processWindowEvent(WindowEvent e) {
	    //super.processWindowEvent(e);
	    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
	    	ScreenEventProvider.close();
	    }
	}
	
	private static GUIFrame frame = new GUIFrame();
	
	public static GUIFrame getFrame() {
		    return frame;
		  }

	public static void setButtonsStop() {
		getFrame().startStop.setText("Start");
		getFrame().pauseContinue.setEnabled(false);
	}
	
	public static void setButtonsRun() {
		getFrame().startStop.setText("Stop");
		getFrame().pauseContinue.setEnabled(true);
		getFrame().pauseContinue.setText("Pause");
	}
	
	public static void setButtonsPause() {
		getFrame().startStop.setText("Stop");
		getFrame().pauseContinue.setEnabled(true);
		getFrame().pauseContinue.setText("Continue");
	}
}
